'use strict';

Object.defineProperty(exports, "__esModule", {
		value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _withPopover = require('./withPopover');

var _withPopover2 = _interopRequireDefault(_withPopover);

var _OutsideClickListener = require('./OutsideClickListener');

var _OutsideClickListener2 = _interopRequireDefault(_OutsideClickListener);

var _RTGDropdown = require('./RTGDropdown');

var _RTGDropdown2 = _interopRequireDefault(_RTGDropdown);

var _helperFunctions = require('./helperFunctions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DropdownPopover = function DropdownPopover(_ref) {
		var children = _ref.children,
		    pivotFrom = _ref.pivotFrom,
		    transitionOptions = _ref.transitionOptions,
		    toggle = _ref.toggle,
		    switchOn = _ref.switchOn,
		    _ref$basewidth = _ref.basewidth,
		    basewidth = _ref$basewidth === undefined ? 20 : _ref$basewidth,
		    _ref$triggerX = _ref.triggerX,
		    triggerX = _ref$triggerX === undefined ? 5 : _ref$triggerX,
		    _ref$paddingX = _ref.paddingX,
		    paddingX = _ref$paddingX === undefined ? 0 : _ref$paddingX,
		    switchOff = _ref.switchOff,
		    isOn = _ref.isOn,
		    debugMode = _ref.debugMode,
		    renderTrigger = _ref.renderTrigger,
		    parentName = _ref.parentName,
		    shouldToggleOnHover = _ref.shouldToggleOnHover;

		var containerRef = _react2.default.createRef();
		var inputType = 'mouse';

		typeof window !== 'undefined' && (0, _helperFunctions.onUserInputChange)(function (type) {
				inputType = type;
		});

		var getTriggerProps = function getTriggerProps() {
				var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

				var _onClick = _ref2.onClick,
				    className = _ref2.className,
				    style = _ref2.style,
				    props = (0, _objectWithoutProperties3.default)(_ref2, ['onClick', 'className', 'style']);
				return (0, _extends3.default)({
						onClick: function onClick(e) {
								for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
										args[_key - 1] = arguments[_key];
								}

								e.stopPropagation();
								toggle();
								_onClick && _onClick.apply(undefined, [e].concat(args));
						},
						style: style,
						className: className ? 'dropdownpopover__trigger ' + parentName + '__dropdownpopover__trigger ' + className : 'dropdownpopover__trigger ' + parentName + '__dropdownpopover__trigger'
				}, props);
		};

		var getChildrenProps = function getChildrenProps() {
				var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

				var _onClick2 = _ref3.onClick,
				    className = _ref3.className,
				    style = _ref3.style,
				    props = (0, _objectWithoutProperties3.default)(_ref3, ['onClick', 'className', 'style']);
				return (0, _extends3.default)({
						//onClick: callAll(onClick, toggle),
						onClick: function onClick(e) {
								for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
										args[_key2 - 1] = arguments[_key2];
								}

								e.stopPropagation();
								toggle();
								_onClick2 && _onClick2.apply(undefined, [e].concat(args));
						},
						style: style,
						className: className ? 'dropdownpopover__children ' + className : 'dropdownpopover__children'
				}, props);
		};
		var padding_x = paddingX;
		var trigger_x = triggerX;
		var getStyle = function getStyle() {
				console.log(trigger_x, basewidth);
				if (pivotFrom === 'DOWNRIGHT') {
						return { left: 0 };
				}
				if (pivotFrom === 'DOWNLEFT') {
						return { left: trigger_x + padding_x / 2 - basewidth + 'rem' };
				}
		};
		return _react2.default.createElement(
				_OutsideClickListener2.default,
				{
						containerRef: containerRef,
						shouldCallHandler: isOn,
						handler: toggle
				},
				_react2.default.createElement(_style2.default, {
						styleId: '2264903142',
						css: '.selectone__trigger{width:' + trigger_x + 'rem;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-box-pack:justify;-webkit-justify-content:space-between;-ms-flex-pack:justify;justify-content:space-between;background-color:#fff;border-color:#d9d9d9 #ccc #b3b3b3;border:1px solid #ccc;color:#333;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;height:2.75rem;outline:none;overflow:hidden;position:relative;}.selectone__option{cursor:pointer;padding:0.5rem 0.75rem;-webkit-transition:all 100ms ease-in-out;transition:all 100ms ease-in-out;background-color:#fafafa;border-color:#d9d9d9 #ccc #b3b3b3;margin:1px;color:#333;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;border-spacing:0;border-collapse:separate;outline:none;overflow:hidden;position:relative;}.selectone__option--inactive{background-color:#fafafa;}.selectone__option--inactive:hover{background:whitesmoke;}.selectone__option--active{background-color:#eeffff;}.selectone__option--active:hover{background:#ddffff;}.selectmany__trigger{width:' + trigger_x + 'rem;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;-webkit-box-pack:justify;-webkit-justify-content:space-between;-ms-flex-pack:justify;justify-content:space-between;background-color:#fff;border-color:#d9d9d9 #ccc #b3b3b3;border:1px solid #ccc;color:#333;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;height:2.75rem;outline:none;overflow:hidden;position:relative;}.selectmany__option{cursor:pointer;padding:0.5rem 0.75rem;-webkit-transition:all 100ms ease-in-out;transition:all 100ms ease-in-out;background-color:#fafafa;border-color:#d9d9d9 #ccc #b3b3b3;margin:1px;color:#333;cursor:pointer;display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;border-spacing:0;border-collapse:separate;outline:none;overflow:hidden;position:relative;}.selectmany__option--inactive{background-color:#fafafa;}.selectmany__option--inactive:hover{background:whitesmoke;}.selectmany__option--active{background-color:#eeffff;}.selectmany__option--active:hover{background:#ddffff;}.dropdownpopover__trigger{cursor:pointer;width:' + trigger_x + 'rem;}.dropdownpopover__container{position:relative;z-index:2;}.dropdownpopover__children{position:absolute;background:#e2e2e2;z-index:1;}.dropdownpopover__children .button.button--link{border-bottom:1px solid #fafafa;}.dropdownpopover__children .button.button--link:last-child{border-bottom:none;}',
						dynamic: [trigger_x, basewidth, trigger_x, basewidth, trigger_x]
				}),
				_react2.default.createElement(
						'div',
						{
								ref: containerRef,

								onMouseEnter: function onMouseEnter() {
										return inputType === 'mouse' && shouldToggleOnHover && switchOn();
								},
								onMouseLeave: function onMouseLeave() {
										return inputType === 'mouse' && shouldToggleOnHover && switchOff();
								},
								className: _style2.default.dynamic([['2264903142', [trigger_x, basewidth, trigger_x, basewidth, trigger_x]]]) + ' ' + ('dropdownpopover__container ' + parentName + '__dropdownpopover__container')
						},
						renderTrigger({ isOn: isOn, toggle: toggle, getTriggerProps: getTriggerProps }),
						_react2.default.createElement(
								_RTGDropdown2.default,
								{
										style: (0, _extends3.default)({
												width: basewidth + 'rem'
										}, getStyle()),
										'in': debugMode && debugMode.alwaysOn ? true : isOn,
										transitionOptions: transitionOptions,
										className: 'dropdownpopover__children ' + parentName + '__dropdownpopover__children'
								},
								typeof children === 'function' ? children({ isOn: isOn, toggle: toggle, getChildrenProps: getChildrenProps }) : children
						)
				)
		);
};

DropdownPopover.propTypes = {
		children: _propTypes2.default.oneOfType([_propTypes2.default.node, _propTypes2.default.func]).isRequired,
		parentName: _propTypes2.default.string.isRequired,
		renderTrigger: _propTypes2.default.func.isRequired,
		//
		toggle: _propTypes2.default.func.isRequired,
		switchOn: _propTypes2.default.func.isRequired,
		switchOff: _propTypes2.default.func.isRequired,
		isOn: _propTypes2.default.bool.isRequired
};

DropdownPopover.defaultProps = {
		isOn: false
};

var enhance = (0, _recompose.compose)(_withPopover2.default);

exports.default = enhance(DropdownPopover);