'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _style = require('styled-jsx/style');

var _style2 = _interopRequireDefault(_style);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _recompose = require('recompose');

var _DropdownPopover = require('./DropdownPopover');

var _DropdownPopover2 = _interopRequireDefault(_DropdownPopover);

var _SVGMenu = require('./svg/SVGMenu');

var _SVGMenu2 = _interopRequireDefault(_SVGMenu);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var HorizontalMenu = function HorizontalMenu(_ref) {
  var children = _ref.children;
  return _react2.default.createElement(
    'div',
    { className: 'flexiblemenu__menu--horizontal' },
    children
  );
};

var DropdownMenu = function DropdownMenu(_ref2) {
  var children = _ref2.children,
      pivotFrom = _ref2.pivotFrom,
      _renderTrigger = _ref2.renderTrigger,
      debugMode = _ref2.debugMode,
      _ref2$triggerX = _ref2.triggerX,
      triggerX = _ref2$triggerX === undefined ? 3 : _ref2$triggerX;

  var triggerBaseClassName = 'flexiblemenu__trigger';
  var defaultRenderTrigger = function defaultRenderTrigger(_ref3) {
    var getTriggerProps = _ref3.getTriggerProps,
        isOn = _ref3.isOn;
    return _react2.default.createElement(
      _Button2.default,
      { type: 'menutoggle', settings: { on: '#c4c4c4', off: '#eeeeee', diff: 10 } },
      function (_ref4) {
        var getButtonProps = _ref4.getButtonProps;
        return _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps((0, _extends3.default)({}, getTriggerProps({
            style: { padding: '0.5rem', width: triggerX - 1 + 'rem' }
          }), {
            className: triggerBaseClassName,
            isOn: isOn
          }))),
          _react2.default.createElement(_SVGMenu2.default, null)
        );
      }
    );
  };
  return _react2.default.createElement(
    'div',
    {
      className: 'jsx-3100070431' + ' ' + 'flexiblemenu__menu--dropdown'
    },
    _react2.default.createElement(_style2.default, {
      styleId: '3100070431',
      css: '.flexiblemenu__menu--horizontal{display:-webkit-box;display:-webkit-flex;display:-ms-flexbox;display:flex;}.flexiblemenu__menu--dropdown{position:relative;}'
    }),
    _react2.default.createElement(
      _DropdownPopover2.default,
      {
        debugMode: debugMode,
        triggerX: triggerX,
        pivotFrom: pivotFrom,
        renderTrigger: function renderTrigger(_ref5) {
          var _getTriggerProps = _ref5.getTriggerProps,
              isOn = _ref5.isOn;
          return _renderTrigger ? _renderTrigger({
            getTriggerProps: function getTriggerProps() {
              var _ref6 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

              var className = _ref6.className,
                  props = (0, _objectWithoutProperties3.default)(_ref6, ['className']);
              return _getTriggerProps((0, _extends3.default)({
                className: triggerBaseClassName + ' ' + (className ? className : '')
              }, props));
            },
            isOn: isOn
          }) : defaultRenderTrigger({ getTriggerProps: _getTriggerProps, isOn: isOn });
        },
        parentName: 'flexiblemenu'
      },
      children
    )
  );
};

var enhance = (0, _recompose.compose)((0, _recompose.defaultProps)({
  showHorizontal: true
}), (0, _recompose.branch)(function (_ref7) {
  var isHorizontal = _ref7.isHorizontal,
      showHorizontal = _ref7.showHorizontal;
  return showHorizontal && isHorizontal;
}, (0, _recompose.renderComponent)(HorizontalMenu), (0, _recompose.renderComponent)((0, _recompose.compose)((0, _recompose.branch)(function (_ref8) {
  var isHorizontal = _ref8.isHorizontal;
  return !isHorizontal;
}, (0, _recompose.renderComponent)(DropdownMenu), _recompose.renderNothing)(DropdownMenu)))), (0, _recompose.onlyUpdateForKeys)(['children', 'pivotFrom', 'isHorizontal']));
exports.default = enhance(HorizontalMenu);