'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import {connect} from 'react-redux'
var Switch = function Switch(_ref) {
	var children = _ref.children,
	    activeOption = _ref.activeOption,
	    setActiveOption = _ref.setActiveOption;

	var isActive = function isActive(option) {
		return activeOption === option;
	};
	var getOptionProps = function getOptionProps() {
		var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref2.className,
		    style = _ref2.style,
		    _onClick = _ref2.onClick,
		    option = _ref2.option,
		    props = (0, _objectWithoutProperties3.default)(_ref2, ['className', 'style', 'onClick', 'option']);

		return (0, _extends3.default)({
			onClick: function onClick(e) {
				for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
					args[_key - 1] = arguments[_key];
				}

				e.stopPropagation;
				setActiveOption(option);
				_onClick && _onClick.apply(undefined, [e].concat(args));
			},
			className: className ? (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option', 'active', 'inactive') + ' ' + (0, _helperFunctions.flippyClass)(isActive(option), className, 'active', 'inactive') : '' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option', 'active', 'inactive'),
			style: style
		}, props);
	};
	var getContentProps = function getContentProps() {
		var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref3.className,
		    _ref3$style = _ref3.style,
		    style = _ref3$style === undefined ? {} : _ref3$style,
		    _onClick2 = _ref3.onClick,
		    option = _ref3.option,
		    props = (0, _objectWithoutProperties3.default)(_ref3, ['className', 'style', 'onClick', 'option']);

		var getDefaultStyle = function getDefaultStyle(option) {
			return {
				transition: 'all 150ms ease-in-out',
				opacity: isActive(option) ? 1 : 0,
				maxHeight: isActive(option) ? '10rem' : 0
			};
		};
		return (0, _extends3.default)({
			onClick: function onClick(e) {
				for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
					args[_key2 - 1] = arguments[_key2];
				}

				e.stopPropagation;
				_onClick2 && _onClick2.apply(undefined, [e].concat(args));
			},
			className: className ? (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive') + ' ' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive') : '' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive'),
			style: (0, _extends3.default)({}, getDefaultStyle(option), style)
		}, props);
	};
	var getLabelProps = function getLabelProps() {
		var _ref4 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

		var className = _ref4.className,
		    style = _ref4.style,
		    _onClick3 = _ref4.onClick,
		    option = _ref4.option,
		    props = (0, _objectWithoutProperties3.default)(_ref4, ['className', 'style', 'onClick', 'option']);

		return (0, _extends3.default)({
			onClick: function onClick(e) {
				for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
					args[_key3 - 1] = arguments[_key3];
				}

				e.stopPropagation;
				_onClick3 && _onClick3.apply(undefined, [e].concat(args));
			},
			className: className ? (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive') + ' ' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive') : '' + (0, _helperFunctions.flippyClass)(isActive(option), 'switch__option__content', 'active', 'inactive')

		}, props);
	};

	return children({ getOptionProps: getOptionProps, getContentProps: getContentProps, getLabelProps: getLabelProps, activeOption: activeOption, isActive: isActive });
};

Switch.propTypes = {
	children: _propTypes2.default.func.isRequired
};

var enhance = (0, _recompose.compose)((0, _recompose.withStateHandlers)(function (_ref5) {
	var _ref5$defaultValue = _ref5.defaultValue,
	    defaultValue = _ref5$defaultValue === undefined ? '0' : _ref5$defaultValue;
	return { activeOption: defaultValue };
}, {
	setActiveOption: function setActiveOption() {
		return function (value) {
			return { activeOption: value };
		};
	}
}));

exports.default = enhance(Switch);